#include <stdio.h>
#include <stdlib.h>
/* generate H-rep of holographic entry cone on K_N with terminals 0,1,2,...,n-1<N */

int N,M,E,n;            /* max N is 10 */
int A[50][50];
int position=0;
int col[10000];      /* column location of subset I when converted to integer */

int power(int base, int exponent)
 {
         int result, i;

         result = 1;
         for (i = 0; i < exponent; i++)
                 result = result * base;

         return result;
 }


    /*  Function to generate combination  */
    void combinationUtil(int arr[], int data[], int start, int end, int index, int r, int n)

    {
        int j, i;
        int binary[10000];
        int ind;
        // Current combination is ready to be printed, print it
        for(i=1;i<=n;i++)
            binary[i]=0;
        ind=0;
        if (index == r) {
            for (j = 0; j < r; j++)
               {
             /*   printf("%d ", data[j]); */
                ind=ind+power(2,data[j]-1);
                binary[data[j]]=1;
               }
        position++;
        col[ind]=position;
            return;
        }
    
        // replace index with all possible elements. The condition
        // "end-i+1 >= r-index" makes sure that including one element
        // at index will make a combination with remaining elements
        // at remaining positions
        for (i = start; i <= end && end - i + 1 >= r - index; i++)
        {
            data[index] = arr[i];
            combinationUtil(arr, data, i + 1, end, index + 1, r, n);
        }
    }
    /*  End of combinationutil()  */

   /*  Function to print the combination  */
    void printCombination(int arr[], int n, int r)
    {
        int data[r];
        combinationUtil(arr, data, 0, n - 1, 0, r,n);
    }
    /*  End of printCombination()  */


static int read_graph (char *fname);

int main (int ac, char **av)
{
    int i, j, k,  h, head, ind, it;
    int binary[5000];
    int arr[50000], r;
    int testS=0;

/*  for generating cuts on arbitrary graphs
    if (read_graph (av[1])) {
        fprintf (stderr, "could not read graph\n"); return 1;
        }
    fprintf(stderr,"enter N >= n");
    scanf("%d %d",&N,&n);
*/
    if (ac <= 2)
     {
      printf("\nUsage: he N n [1] , N>n");
      return 1;
     }  
    if(ac>=3  && av[3] != 0)    /* any parameter except zero will do  */
      testS=1;
    N=atoi(av[1]);
    n=atoi(av[2]);
    if(N<n) 
     {
      printf("\nUsage: he N n [1] , N>n");
      return 1;
     }  
/* generate column indices for I */
        for (i = 0; i < n; i++)
        {
        arr[i]=i+1;
        }
        for (r = 1; r <= n; r++)
            printCombination(arr, n, r);

/* setup complete graph */

    for (i=0;i<N;i++)
       for (j=0;j<N;j++)
          A[i][j]= (i!=j);

    E=N*(N-1)/2+power(2,n);
    

    M=power(2,N-1);    /* 2**(N-1) */
    printf("*p%d-%d",N,n);
    printf("\n*H-rep of extended holographic entropy cone on K_%d with %d terminals",N,n);
    printf("\nH-representation");
    if(testS)
     {
      printf("\nlinearity %d ",power(2,n)-1);
      for (i=1;i<power(2,n);i++)
         printf(" %d",i+M+E-1-power(2,n));
     }
    printf("\nbegin");
/* rows have to be adjusted for removing cuts with no terminals, ie. ind=0 */
    printf("\n%d %d integer",M-power(2,N-n-1)+N*(N-1)/2+testS*(power(2,n)-1),E);

    for (i = 0; i < 20; i++) binary[i] = 0;

    for (j=1;j<M;j++)
      {
      k=j;
      for (i=0;i<N;i++)
        {
         binary[i]=k % 2;
/*       printf(" %d",binary[i]);  */ 
         k=k/2;
        }

      ind=0;       /* offset for terminal -1 entry */
      for (i=0;i<n;i++)
           ind=ind+binary[i]*power(2,i);
      ind=col[ind];   /* use precomputed column location */

//   printf("\n ind=%d ",ind);            
      if(ind != 0)
      {
       printf("\n0");
/* columns for terminals come first */
       for(i=0;i<power(2,n)-1;i++)
          if(i==ind-1)
              printf(" -1");
          else
              printf("  0");

       printf(" ");
/* now come the cut incidence vectors */
       for(i=0;i<N-1;i++)
         for (k=i+1;k<N;k++)
           {
           h=(binary[i]^binary[k]);
           if(A[i][k])
              printf(" %d",h);
           }
       }    /* ind=0 */
    }
    

/*  nonnegativity constraints */
      for (i=power(2,n);i<=E-1;i++)
      {
        printf("\n0");
        for (j=1;j<=E-1;j++)
          printf(" %d",i==j);
      }
      if(testS)       /* linearity for inputing S vector */
        for(i=1;i<power(2,n);i++)
           {
           printf("\n0");
           for (j=1;j<=E-1;j++)
                if (i==j)
                    printf(" -1");
                else
                    printf(" 0");
            } 
           

    printf("\nend\n");
    return 0;
}

